﻿using C1.C1Preview;
using C1.C1Report;
using C1.Web.Wijmo.Controls.C1ReportViewer;
using C1ReportInMVC.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace C1ReportInMVC.Controllers
{
    public class ReportController : Controller
    {
        string dbPath = "|DATADIRECTORY|\\TwoTables.mdb";
        string docName, rptName, rptPath, query;

        public ActionResult Demo()
        {
            var country = this.Request["ddlCountry"];

            if (country == null)
            {
                query = "SELECT DISTINCT [Ten Most Expensive Products].TenMostExpensiveProducts, [Ten Most Expensive Products].UnitPrice FROM [Ten Most Expensive Products];";
                rptPath = HttpContext.Server.MapPath("~/ReportLayout/MostExpensive.xml");
                docName = "MostExpensive";
                rptName = docName;
            }
            else
            {
                query = "SELECT DISTINCT [Quarterly Orders].CustomerID, [Quarterly Orders].CompanyName,[Quarterly Orders].City, [Quarterly Orders].Country FROM  [Quarterly Orders] WHERE [Quarterly Orders].Country = \"" + country + "\";";
                rptPath = HttpContext.Server.MapPath("~/ReportLayout/QuarterlyOrdersReport.xml");
                docName = "Quarterly Orders Report";
                rptName = docName;

                if (C1ReportViewer.IsDocumentRegistered(docName))
                {
                    C1ReportViewer.UnRegisterDocument(docName);
                }
            }

            C1ReportViewer.RegisterDocument(docName, MakeDoc);

            ReportModel model = new ReportModel(docName, rptName + "_" + country, new string[] { "All", "Austria", "Germany", "UK", "USA" }, country ?? "All");

            return View(model);
        }

        public C1PrintDocument MakeDoc()
        {
            C1Report report = new C1Report();

            report.Load(rptPath, rptName);
            report.DataSource.ConnectionString = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + dbPath + ";Persist Security Info=False";
            report.DataSource.RecordSource = query;
            report.Render();
            return report.C1Document;
        }
    }
}
